var AdapterUppod = $.extend({}, AdapterPlayer, {
	
	_startTime: 0,
	
	init: function (url, start, type, id) {
		
		this._startTime = start;
		
		var _init = function (_url) {
			
			_url = encodeURIComponent(_url);
			
			_log(_url);
							
			swfobject.embedSWF("./app/flash/uppod-osmf.swf", 'player', '100%', '100%', "10.0.0.0", false, {
				file: _url,
				auto: 'play',
				uid: 'player_uppod',
				st: './app/flash/uppod-skin.txt'
			}, {
				allowScriptAccess: 'always',
				bgcolor:"#000000",
				wmode: 'direct'
			});
			
		}
		
		if (url.indexOf('f4m') != -1) {
		
			$.get(url, null, function (data) {
			
				$.post('http://playontv.net/mvc/publications/tv/makef4m/', {mac: Main.GetMac(), film_id: id, xml: data}, function (url) {
					_init(url);
				});
					
			}, 'text');
				
		}
		else {
			_init(url);
		}
		
	},
	
	play: function () {
		uppodSend('play');
	},
	
	pause: function () {
		uppodSend('pause');
	},
	
	destroy: function () {
		uppodSend('clear');
		swfobject.removeSWF("player");
	},
	
	isPaused: function () {
		return (uppodGet('getstatus') != 1);
	},
	
	getCurrentTime: function () {
		return uppodGet('getime');
	},
	
	getDuration: function () {
		return uppodGet('getimed');
	},
	
	seekTo: function(skipSeconds) {
		uppodSend('seek:' + parseInt(skipSeconds));
		this.play();
	},
	
	onEnd: function () {},
	onError: function () {},
	onPlay: function () {},
	onInit: function () {},
	onBuffer: function () {},
	onBufferEnd: function () {}
	
});


function uppodEvent(playerID, event) {
	
	switch(event) {

		case 'end':
				AdapterUppod.onEnd();
			break;
		case 'error':
				AdapterUppod.onError();
			break;
		case 'play':
				AdapterUppod.onPlay();
				AdapterUppod.onBufferEnd();
			break;
		case 'init':
				AdapterUppod.onInit();
			break;
		case 'start':
				AdapterUppod._onStart();
			break;
			
	}
	
}

function uppodGet(event) {
	try {
		if (typeof(document.getElementById('player').getUppod) == 'function') {
			return document.getElementById('player').getUppod(event);
		}
	}
	catch (e) {
		AdapterUppod.onError(e.message);
	}
}

function uppodSend(event) {
	try {
		if (typeof(document.getElementById('player').sendToUppod) == 'function') {
			document.getElementById('player').sendToUppod(event);
		}
	}
	catch (e) {
		AdapterUppod.onError(e.message);
	}
}