/**
 * Аддон к jquery оптимизирующий работу jqeury c движком smartTV
 */
(function ($) {	
	
	$.fn.html = function (content) {
		
		var _return = '';
		
		this.each(function() {
			
			if (typeof(content) == 'undefined') {
				_return = this.innerHTML;
			}
			else {
				//this.innerHTML = content;
				widgetAPI.putInnerHTML(this, content);
				return this;
			}
			
		});
		
		return _return;

	}
	
	$.fn.tmp = function(string, data) {
		var tmpl = doT.template(string);
		if (!$.isArray(data)) data = [data];
		
		return this.each(function() {
		    var html = '';
		    for (var itemIdx = 0; itemIdx < data.length; itemIdx++) {
		        html += tmpl(data[itemIdx]);
		    }
		    $(this).html(html);
		});
	}
	
	$.fn.tmpPrepend = function(string, data) {
		var tmpl = doT.template(string);
		if (!$.isArray(data)) data = [data];
		
		return this.each(function() {
		    var html = '';
		    for (var itemIdx = 0; itemIdx < data.length; itemIdx++) {
		        html += tmpl(data[itemIdx]);
		    }
		    $(this).prepend(html);
		});
	}
	
	var XHRObj = null;
	$.ajaxSettings.xhr = function () {
		try {

			if (XHRObj != null && typeof(XHRObj.destroy) == 'function') {
				alert('// XMLHttpRequest destroy')
				XHRObj.destroy();
			}
			XHRObj = new window.XMLHttpRequest();
			
			return XHRObj;

		} catch( e ) {}

	}

	$.ajaxSetup({
		cache: false,
		beforeSend: function () {
			throbberDots('show', 'h1');
			Main.blockKeys();
		},
		complete: function () {
			throbberDots('hide');
			Main.unBlockKeys();
		},
		data: {
            mac: Main.GetMac(),
            version: Main.version()
        },
        error: function(jqXHR, exception) {
        	
        	Main.unBlockKeys();
        	
            if (jqXHR.status === 0) {
                Dialog.alert('Нет подключения к интернету. Проверьте настройки сети.');
            } 
            else if (jqXHR.status == 404) {
                Dialog.alert('Запрос выдал 404 ошибку. Страница не найдена.');
            } 
            else if (jqXHR.status == 500) {
                Dialog.alert('Запрос выдал 500 ошибку. Ошибка сервера.');
            } 
            else if (exception === 'parsererror') {
                Dialog.alert('Не возможно обработать json ответ от сервера.');
            } 
            else if (exception === 'timeout') {
                Dialog.alert('Истекло время ожидания сервера.');
            } 
            else if (exception === 'abort') {
                Dialog.alert('Запрос ajax прерван.');
            } 
            else {
                Dialog.alert('Неизвестная ошибка "' + jqXHR.responseText + '"');
            }

        }
    });

})(jQuery);