/**
 * Страница избранное
 */
var FavoritesScene = $.extend({}, IndexScene, {

	onPressReturn: function () {
		this.jumpTo('index');
	},
	
	onPressA: function() { },
	
	_adapterObserver: function () {

		var _this = this;

		httpTransport.getFovoriteFilms(IndexScene._lastFilmId, function (data) {
			if (Scene.current.name == _this.name) {
				_this.writeFilms(data);
			}
		});
			
	},
	
	_templates: {
		
		index: function () {
			
			return '<div id="index_scene">\
						<img id="logo" src="./app/images/logo.png"/>\
						<h1>Ваши избранные видеофайлы<span id="throbber_placeholder"></span></h1>\
						<div id="films"></div>\
					</div>\
					<div id="bottom_images">\
						<div class="info">Ваш SmartID: {{=it.mac}}</div>\
						<span id="green">Убрать из избранного</span>\
						<span id="blue">Удалить</span>\
						<span id="ff">Играть всё</span>\
						<span id="info">Помощь</span>\
						<span id="return">Мои фильмы</span>\
					</div>\
				';
			
		},
		
		rowFilm: function () {
			
			return '{{? it.favorite }}<li id="film_{{=it.publication_id}}" data-id="{{=it.publication_id}}" data-url="{{=it.url}}" data-content_type="{{=it.content_type}}">\
				{{? it.favicon }}<img src="{{=it.favicon}}"/>{{?}}\
				<div><span>{{=it.title}}</span>\
					{{? it.favorite }}<i class="favorite"></i>{{?}}\
				</div>\
			</li>{{?}}';
			
		}
		
	}

});
